﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace QQPlus.Cloud
{
    public partial class FormConfig : QQPlus.Forms.FormBase
    {
        private CloudPlugin plugin;
        private ClusterConfig cc;

        public FormConfig()
        {
            InitializeComponent();
        }

        public FormConfig(CloudPlugin plugin, ClusterConfig cc)
            : this()
        {
            // TODO: Complete member initialization
            this.plugin = plugin;
            this.cc = cc;
        }

        private void FormConfig_Load(object sender, EventArgs e)
        {
            plugin.client.Config.ExtcreditsType.ForEach(t=>cmbExtcredits.Items.Add(t));
            this.Text = cc.ExternalId.ToString();
            chkStatus.Checked = cc.Status;
            cmbExtcredits.SelectedIndex = (int)cc.ExtcreditsType;
            numExtcreditsCount.Value = cc.ExtcreditsCount;
            txtLang1.Text = cc.Lang1;
            txtLang2.Text = cc.Lang2;
        }

        private void btnSave_Click(object sender, EventArgs e)
        {
            cc.Status = chkStatus.Checked;
            cc.ExtcreditsType = cmbExtcredits.SelectedIndex;
            cc.ExtcreditsCount = (long) numExtcreditsCount.Value;
            cc.Lang1 = txtLang1.Text;
            cc.Lang2 = txtLang2.Text;
            db.SaveClusterConfig(cc);
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            Close();
        }
    }
}
