﻿using QQPlus.Framework.SDK;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using QQPlus.Framework.Utils;

namespace QQPlus.DOS
{
    class DOSPlugin : Plugin
    {
        public DOSPlugin()
        {
            this.Id = "QQPlus.DOSPlugin";
            this.PluginName = "DOS命令";
            this.Description = "除了执行DOS命令，还可以运行其他软件，帮助指令：cmd，需要机器人管理员权限";
            this.PluginId = 162;
        }

        public override bool Start()
        {
            sdk = new QQClientSDK();
            sdk.ReceiveTempIM += sdk_ReceiveTempIM;
            sdk.ReceiveSubjectIM += sdk_ReceiveSubjectIM;
            sdk.ReceiveClusterIM += sdk_ReceiveClusterIM;
            sdk.ReceiveNormalIM += sdk_ReceiveNormalIM;
            return base.Start();
        }

        void sdk_ReceiveTempIM(object sender, ReceiveTempIMQQEventArgs e)
        {
            if (client.Config.AdminQQs.Contains(e.QQ))
            {
                var result = Execute(e.Message);
                if (!string.IsNullOrWhiteSpace(result))
                {
                    OnLog("给{0}发送消息：{1}", e.QQ, result);
                    client.SendTempMessage(e.ExternalId, e.QQ, result);
                }
            }
        }

        void sdk_ReceiveSubjectIM(object sender, ReceiveSubjectIMQQEventArgs e)
        {
            if (client.Config.AdminQQs.Contains(e.QQ))
            {
                var result = Execute(e.Message);
                if (!string.IsNullOrWhiteSpace(result))
                {
                    OnLog("给讨论组{0}发送消息：{1}", e.ClusterId, result);
                    client.SendSubjectMessage(e.ClusterId, result);
                }
            }
        }

        void sdk_ReceiveClusterIM(object sender, ReceiveClusterIMQQEventArgs e)
        {
            if (client.Config.AdminQQs.Contains(e.ClusterMember.QQ))
            {
                var result = Execute(e.Message);
                if (!string.IsNullOrWhiteSpace(result))
                {
                    OnLog("给{0}群发送消息：{1}", e.Cluster.ExternalId, result);
                    client.SendClusterMessage(e.Cluster.ExternalId, result);
                }
            }
        }

        void sdk_ReceiveNormalIM(object sender, ReceiveNormalIMQQEventArgs e)
        {
            if (client.Config.AdminQQs.Contains(e.QQ))
            {
                var result = Execute(e.Message);
                if (!string.IsNullOrWhiteSpace(result))
                {
                    OnLog("给QQ{0}发送消息：{1}", e.QQ, result);
                    client.SendMessage(e.QQ, result);
                }
            }
        }

        string Execute(string msg)
        {
            if (msg.Equals("cmd", StringComparison.InvariantCultureIgnoreCase))
            {
                return @"请发送：cmd+空格+dos命令，例如：cmd tasklist
cmd net user
cmd netstat -ano
shutdown -s -t 00
cmd notepad";
            }
            else if (msg.StartsWith("cmd ", StringComparison.InvariantCultureIgnoreCase))
            {
                return CmdUtil.ExeCommand(msg.Substring(4));
            }

            return null;
        }
    }
}
